//#include "testlib.h"
 
#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <set>
#include <numeric>
#include <map>
#include <queue>
 
using namespace std;
 
int n, m;
int A[1111][1111];
int s[1111][1111];
int mx[1111][1111];
int dq[1111][1111];
int f[1111], l[1111];
int ddq[1111];
int ff, ll;
 
void pp(int a, int b) {
    for(int j = 1; j <= m; ++j)
        f[j] = 0, l[j] = -1;
    
    for(int i = 1; i <= a; ++i)
        for(int j = 1; j <= m; ++j) {
            while (f[j] <= l[j] && dq[j][l[j]] < A[i][j]) l[j]--;
            dq[j][++l[j]] = A[i][j];
        }
    
    for(int i = a; i <= n; ++i) {
        ff = 0, ll = -1;
        for(int j = 1; j <= b; ++j) {
            while (ff <= ll && ddq[ll] < dq[j][f[j]]) ll--;
            ddq[++ll] = dq[j][f[j]];
        }
        
        for(int j = b; j <= m; ++j) {
            mx[i][j] = ddq[ff];
            
            if (ddq[ff] == dq[j-b+1][f[j-b+1]]) ff++;
            if (j+1 <= m) {
                while (ff <= ll && ddq[ll] < dq[j+1][f[j+1]]) ll--;
                ddq[++ll] = dq[j+1][f[j+1]];
            }
        }
        
        for(int j = 1; j <= m; ++j)
            if (dq[j][f[j]] == A[i-a+1][j])
                f[j]++;
        
        if (i+1 <= n)
            for(int j = 1; j <= m; ++j) {
                while(f[j] <= l[j] && dq[j][l[j]] < A[i+1][j]) l[j]--;
                dq[j][++l[j]] = A[i+1][j];
            }
    }
}
 
int main() {
    ios::sync_with_stdio(0);
    cin >> n >> m;
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= m; ++j)
            cin >> A[i][j];
    
    
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= m; ++j)
            s[i][j] = A[i][j] + s[i-1][j] + s[i][j-1] - s[i-1][j-1];
    
    int t, a, b;
    cin >> t;
    while (t --> 0) {
        cin >> a >> b;
        
        pp(a, b);
        
        int ans = 1e9+10;
        for(int i = a; i <= n; ++i)
            for(int j = b; j <= m; ++j)
                ans = min(ans, mx[i][j] * a * b - (s[i][j] - s[i][j-b] - s[i-a][j] + s[i-a][j-b]));
        
        cout << ans << "\n";
    }
    //cout << clock() / (double) CLOCKS_PER_SEC << "\n";
    return 0;
}
 